--8ball v1.4 by Odlaw

EightBallAuto = 0;
EightBallYesNo = {};
EightBallYesNo[1] = "do";
EightBallYesNo[2] = "dont";
EightBallYesNo[3] = "did";
EightBallYesNo[4] = "didnt";
EightBallYesNo[5] = "does";
EightBallYesNo[6] = "doesnt";
EightBallYesNo[7] = "have";
EightBallYesNo[8] = "havent";
EightBallYesNo[9] = "has";
EightBallYesNo[10] = "hasnt";
EightBallYesNo[11] = "can";
EightBallYesNo[12] = "cant";
EightBallYesNo[13] = "could";
EightBallYesNo[14] = "couldnt";
EightBallYesNo[15] = "may";
EightBallYesNo[16] = "might";
EightBallYesNo[17] = "will";
EightBallYesNo[18] = "wont";
EightBallYesNo[19] = "would";
EightBallYesNo[20] = "wouldnt";
EightBallYesNo[21] = "shall";
EightBallYesNo[22] = "should";
EightBallYesNo[23] = "shouldnt";
EightBallYesNo[24] = "is";
EightBallYesNo[25] = "isnt";
EightBallYesNo[26] = "are";
EightBallYesNo[27] = "arent";
EightBallYesNo[28] = "any";
EightBallYesNo[29] = "anything";
EightBallYesNo[30] = "was";
EightBallYesNo[31] = "wasnt";
EightBallYesNo[32] = "ever seen";
EightBallYesNo[33] = "ever see";
EightBallNonYesNo = {};
EightBallNonYesNo[1] = "who";
EightBallNonYesNo[2] = "whos";
EightBallNonYesNo[3] = "what";
EightBallNonYesNo[4] = "whats";
EightBallNonYesNo[5] = "when";
EightBallNonYesNo[6] = "where";
EightBallNonYesNo[7] = "whered";
EightBallNonYesNo[8] = "wheres";
EightBallNonYesNo[9] = "why";
EightBallNonYesNo[10] = "how";
EightBallNonYesNo[11] = "hows";
EightBallNonYesNo[12] = "%Aor";
EightBallNonYesNo[13] = "^or";
EightBallNonYesNo[14] = "which";
EightBallException = {};
EightBallException[1] = "is that how";
EightBallException[2] = "is this how";
EightBallException[3] = "is that why";
EightBallException[4] = "is this why";
EightBallException[5] = "is that where";
EightBallException[6] = "is this where";
EightBallException[7] = "is that what";
EightBallException[8] = "is this what";
EightBallException[9] = "is that who";
EightBallException[10] = "is this who";
EightBallException[11] = "is that when";
EightBallException[12] = "is this when";

function EightBall ()
  local randnum = random(20);
  local saying = {};
    saying[1] = "Signs point to yes."
    saying[2] = "Yes."
    saying[3] = "Most likely."
    saying[4] = "Without a doubt."
    saying[5] = "Yes - definately."
    saying[6] = "As I see it, yes."
    saying[7] = "You may rely on it."
    saying[8] = "Outlook good."
    saying[9] = "It is certain."
    saying[10] = "It is decidedly so."
    saying[11] = "Reply hazy, try again."
    saying[12] = "Better not tell you now."
    saying[13] = "Ask again later."
    saying[14] = "Concentrate and ask again."
    saying[15] = "Cannot predict now."
    saying[16] = "My sources say no."
    saying[17] = "Very doubtful."
    saying[18] = "My reply is no."
    saying[19] = "Outlook not so good."
    saying[20] = "Don't count on it."
    return saying[randnum];
end

function EightBall_SlashCmdHandler(msg)
  msg = string.lower(msg);
  local chattype, chan;
  local a,b,cmd,arg = string.find(msg,"(%S+)%s*(%S*)");

  if ( cmd == "guild" ) then
    chattype = "GUILD";
  elseif ( cmd == "party" ) then
    chattype = "PARTY";
  elseif ( cmd == "say" ) then
    chattype = "SAY";
  elseif ( cmd == "raid" ) then
    chattype = "RAID";
  elseif ( cmd == "bg" ) then
    chattype = "BATTLEGROUND";
  elseif ( cmd == "yell" ) then
    chattype = "YELL";
  elseif ( cmd == "chan" ) then
    if ( GetChannelName(arg) ~= 0 ) then
      chattype = "CHANNEL";
      chan = GetChannelName(arg);
    else
      DEFAULT_CHAT_FRAME:AddMessage("Usage: /8ball [chan <channel name>]");
    end
  elseif ( cmd == "whisper" ) then
    if ( arg ~= "" ) then
      chattype = "WHISPER";
      chan = arg;
    else
      DEFAULT_CHAT_FRAME:AddMessage("Usage: /8ball [whisper <name>]");
    end
  elseif ( cmd == "auto" ) then
    if ( arg == "on" ) then
      EightBallAuto = 1;
      DEFAULT_CHAT_FRAME:AddMessage("8ball automatic response ON");
    elseif ( arg == "off" ) then
      EightBallAuto = 0;
      DEFAULT_CHAT_FRAME:AddMessage("8ball automatic response OFF");
    else
      DEFAULT_CHAT_FRAME:AddMessage("Usage: /8ball [auto <on/off>]");
      if ( EightBallAuto == 1 ) then
        DEFAULT_CHAT_FRAME:AddMessage("8ball automatic response currently set to ON");
      else
        DEFAULT_CHAT_FRAME:AddMessage("8ball automatic response currently set to OFF");
      end
    end
  else
    DEFAULT_CHAT_FRAME:AddMessage("Usage: /8ball [guild | party | raid | bg | yell | say | chan | whisper]");
    DEFAULT_CHAT_FRAME:AddMessage("/8ball [auto <on/off>]  - Turns on/off automatic replies to yes/no questions");
  end
  if ( chattype ) then
    SendChatMessage("<Shakes the magic 8ball> " ..EightBall(), chattype, nil, chan);
  end
end

--[[Function for Yes/No question recognition
The way we are going to do this, is first a score system to check against
words that do not make sense as a yes/no question, and then check for exceptions
to those words.
IE - how is normally a word that would get -5 to the score, since how questions are not yes/no
     However, questions that have 'is this how' or 'is that how' would be a yes/no
Once we score the system, we check for words that would normally make it a yes/no question
Reason we don't add those words to the scoring system, is by the following question example:
which ones are the ones you can root?  (Which -5, Are +5, Can +5) This isn't a yes/no question
Under the scoring system, we would only get Which -5, and then check the words Are and Can seperatly
Since the score is -5, this is an invalid question, and we don't even have to check are/can

For the time being, I am just gonna process until I hit a match for the scoring system]]

function EightBall_Event()
  local CheckWord, IsAQuestion, chattype, chan, index;
  local score = 0;

  if ( EightBallAuto == 0 ) then
    return;
  end

  arg1 = string.lower(arg1);
  if ( string.find(arg1,".+%?") == nil ) then
    return;
  end
  if ( event == "CHAT_MSG_CHANNEL" ) then
    if ( arg7 ~= 0 ) then
      return;
    end
  end
  if ( string.lower(arg2) == string.lower(UnitName("player")) ) then
    return;
  end
  arg1 = string.gsub(arg1, "'", "");
  for index, CheckWord in EightBallNonYesNo do
    if ( string.find(arg1,CheckWord.."%A") ) then
      score = score - 5;
      break;
    end
  end
  for index, CheckWord in EightBallException do
    if ( string.find(arg1,CheckWord) ) then
      score = score + 5;
      break;
    end
  end
  if ( score < 0 ) then
    return;
  end
  for index, CheckWord in EightBallYesNo do
    if ( string.find(arg1, CheckWord.."%A") ) then
      IsAQuestion = 1;
      break;
    end
  end
  if ( IsAQuestion ) then
    if ( event == "CHAT_MSG_CHANNEL" ) then
      chattype = "CHANNEL";
      chan = GetChannelName(arg9);
    elseif ( event == "CHAT_MSG_GUILD" ) then
      chattype = "GUILD";
    elseif ( event == "CHAT_MSG_PARTY" ) then
      chattype = "PARTY";
    elseif ( event == "CHAT_MSG_RAID" or event == "CHAT_MSG_RAID_LEADER" or event == "CHAT_MSG_RAID_WARNING" ) then
      chattype = "RAID";
    elseif ( event == "CHAT_MSG_SAY" ) then
      chattype = "SAY";
    elseif ( event == "CHAT_MSG_WHISPER" ) then
      chattype = "WHISPER";
      chan = arg2;
    elseif ( event == "CHAT_MSG_YELL" ) then
      chattype = "YELL";
    end
    if ( chattype ) then
      SendChatMessage("<Shakes the magic 8ball> " ..EightBall(), chattype, nil, chan);
--      DEFAULT_CHAT_FRAME:AddMessage("<Shakes the magic 8ball> " ..EightBall());
    end
  end
end

SLASH_EIGHTBALL1 = "/8ball";
SlashCmdList["EIGHTBALL"] = function(msg)
  EightBall_SlashCmdHandler(msg);
end

local EightBallFrame = CreateFrame("Frame");
EightBallFrame:SetScript("OnEvent", EightBall_Event);
EightBallFrame:RegisterEvent("CHAT_MSG_CHANNEL");
EightBallFrame:RegisterEvent("CHAT_MSG_GUILD");
EightBallFrame:RegisterEvent("CHAT_MSG_PARTY");
EightBallFrame:RegisterEvent("CHAT_MSG_RAID");
EightBallFrame:RegisterEvent("CHAT_MSG_RAID_LEADER");
EightBallFrame:RegisterEvent("CHAT_MSG_RAID_WARNING");
EightBallFrame:RegisterEvent("CHAT_MSG_SAY");
EightBallFrame:RegisterEvent("CHAT_MSG_WHISPER");
EightBallFrame:RegisterEvent("CHAT_MSG_YELL");
